## libserial 1.0.0+git20250903

=== CMakeLists.txt ===
#
# Minimum version is 3.10 (this supports Ubuntu 18.04 and later, for example)
#
CMAKE_MINIMUM_REQUIRED(VERSION 3.10)

#
# Project version numbering using semantic versioning. See:
# https://semver.org/
#
# These are used to set VERSION and SOVERSION properties of the LibSerial
# libarary. See:
# - https://cmake.org/cmake/help/latest/prop_tgt/SOVERSION.html
# - https://cmake.org/cmake/help/latest/prop_tgt/VERSION.html
#
PROJECT(LibSerial LANGUAGES C CXX VERSION 1.0.0)

option(LIBSERIAL_ENABLE_TESTING "Enables building unit tests" ON)
option(LIBSERIAL_BUILD_EXAMPLES "Enables building example programs" ON)
option(LIBSERIAL_PYTHON_ENABLE "Enables building the library with Python SIP bindings" ON)
option(LIBSERIAL_BUILD_DOCS "Build the Doxygen docs" ON)

#
# Project specific options and variables
#
OPTION(INSTALL_STATIC "Install static library." ON)
OPTION(INSTALL_SHARED "Install shared object library." ON)

#
# LibSerial requies a C++ compiler that supports at least C++17 standard
#
SET(CMAKE_CXX_STANDARD 17)
SET(CMAKE_STANDARD_REQUIRES ON)

INCLUDE(ExternalProject)

if (LIBSERIAL_ENABLE_TESTING)
  ENABLE_TESTING()
endif()
SET(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

#
# Create compile_commands.json file so that it may be used by various
# editors/plugins/IDEs that support it.
#
SET(CMAKE_EXPORT_COMPILE_COMMANDS 1)

#
# Use GNU standard installation directories. CMake will use /usr/local
# as the default install directory. Users may override this by setting
# CMAKE_INSTALL_PREFIX. For example:
#
# cd build && cmake -DCMAKE_INSTALL_PREFIX=/usr ..
#
INCLUDE(GNUInstallDirs)

#
# Prefer -pthread compiler and linker flag when using libpthread. This must
# be set before call to FIND_PACKAGE(Threads).
#
SET(THREADS_HAVE_PTHREAD_ARG 1)
if (LIBSERIAL_BUILD_DOCS)
  FIND_PACKAGE(Doxygen REQUIRED)
endif()
if (LIBSERIAL_ENABLE_TESTING)
  FIND_PACKAGE(Boost COMPONENTS unit_test_framework REQUIRED)
endif()
if (LIBSERIAL_PYTHON_ENABLE)
  FIND_PACKAGE(PythonLibs REQUIRED)
endif()
#FIND_PACKAGE(SIP REQUIRED)
FIND_PACKAGE(Threads REQUIRED)

#
# Use -DCMAKE_BUILD_TYPE=Release or -DCMAKE_BUILD_TYPE=Debug to let CMake
# decide whether to use debug or optimization flags. We should not hard-code
# them here. Similarly, let CMake handle flags needed for shared object files
# (such as -fPIC). Additionally, "-pthread" flag will also be handled by CMake
# via the use of CMAKE_THREAD_LIBS_INIT (cmake < 3.1) or Threads::Threads.
#
ADD_DEFINITIONS(
  -Wall
  -Wcast-align
  -Wchar-subscripts
  -Wdouble-promotion
  -Wextra
  -Wfatal-errors
  -Wformat
  -Wformat-security
  -Wlogical-op
  -Wno-format-extra-args
  -Wno-long-long
  -Wno-parentheses
  -Wno-psabi
  -Wno-variadic-macros
  -Woverlength-strings
  -Wpacked
  -Wpointer-arith
  -Wunused-local-typedefs
  -Wwrite-strings

  -fstrict-aliasing
  -fno-check-new
  -fno-common
  -fvisibility=default
  -pedantic
  )

if (LIBSERIAL_ENABLE_TESTING)
  FIND_PATH(GTEST_SRCPATH src/gtest.cc
    /usr/src/googletest/googletest
    /usr/src/googletest
    /usr/src/gtest
  )

  FIND_PACKAGE(GTest)
  SET(GTEST_DEPENDENCIES)
  SET(GTestMain gtest gtest_main)
  SET(GTEST_PREFIX "${CMAKE_CURRENT_BINARY_DIR}/gtest")
  if(NOT GTEST_FOUND)
    EXTERNALPROJECT_ADD(GTestExternal
      PREFIX             "${GTEST_PREFIX}"
      URL https://github.com/google/googletest/archive/refs/tags/v1.17.0.tar.gz
      URL_HASH SHA1=8a8ee424e8275ec4b480ba4a0d1ba94b5dee3ee4
      INSTALL_COMMAND ""
      )

    SET(LIBPREFIX "${CMAKE_STATIC_LIBRARY_PREFIX}")
    SET(LIBSUFFIX "${CMAKE_STATIC_LIBRARY_SUFFIX}")

    SET(GTEST_LOCATION "${GTEST_PREFIX}/src/GTestExternal-build/lib")
    SET(GTEST_LIBRARY  "${GTEST_LOCATION}/${LIBPREFIX}gtest${LIBSUFFIX}")
    SET(GTEST_MAINLIB  "${GTEST_LOCATION}/${LIBPREFIX}gtest_main${LIBSUFFIX}")

    ADD_LIBRARY(GTest IMPORTED STATIC GLOBAL)
    SET_TARGET_PROPERTIES(GTest
      PROPERTIES
      IMPORTED_LOCATION "${GTEST_LIBRARY}"
      IMPORTED_LINK_INTERFACE_LIBRARIES "${CMAKE_THREAD_LIBS_INIT}"
      )

    ADD_LIBRARY(GTestMain IMPORTED STATIC GLOBAL)
    SET_TARGET_PROPERTIES(GTestMain
      PROPERTIES
      IMPORTED_LOCATION "${GTEST_MAINLIB}"
      IMPORTED_LINK_INTERFACE_LIBRARIES "${GTEST_LIBRARY};${CMAKE_THREAD_LIBS_INIT}"
      )
    SET(GTestMain GTestMain)
    ADD_DEPENDENCIES(GTest GTestExternal)
    ADD_DEPENDENCIES(GTestMain GTestExternal)

    EXTERNALPROJECT_GET_PROPERTY(GTestExternal source_dir)

    INCLUDE_DIRECTORIES(
      BEFORE ${GTEST_PREFIX}/src/GTestExternal/googletest/include
      ${Boost_INCLUDE_DIRS}
      )
  endif()
endif()

SET(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
SET(CMAKE_INSTALL_MESSAGE ALWAYS)

if (LIBSERIAL_BUILD_EXAMPLES)
  ADD_SUBDIRECTORY(examples)
endif()
if (LIBSERIAL_PYTHON_ENABLE)
  ADD_SUBDIRECTORY(sip)
endif()
ADD_SUBDIRECTORY(src)
if (LIBSERIAL_ENABLE_TESTING)
  ADD_SUBDIRECTORY(test)
endif()

#
# Create pkg-config file for cmake builds as well as autotool builds
#
set(prefix ${CMAKE_INSTALL_PREFIX})
set(exec_prefix ${CMAKE_INSTALL_PREFIX})
set(libdir ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR})
set(includedir ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_INCLUDEDIR})
set(VERSION ${PROJECT_VERSION})
configure_file(libserial.pc.in libserial.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libserial.pc DESTINATION ${libdir}/pkgconfig)

if (LIBSERIAL_BUILD_DOCS)
  CONFIGURE_FILE(
    ${CMAKE_CURRENT_SOURCE_DIR}/doxygen.conf.in
    ${CMAKE_CURRENT_BINARY_DIR}/doxygen.conf.in @ONLY
    )

  ADD_CUSTOM_TARGET(docs ALL
    ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/doxygen.conf.in
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMENT "Generating API documentation with Doxygen" VERBATIM
    )
endif()

#
# Packaging support
#
if (CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
    add_subdirectory(packaging)
endif()

=== packaging/CMakeLists.txt ===
set(CPACK_PACKAGE_NAME                "libserial")
set(CPACK_PACKAGE_CONTACT             "crayzeewulf@gmail.com")
set(CPACK_PACKAGE_VENDOR              "LibSerial developers, testers, users and contibutors")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Linux serial port programming library for C++")
set(CPACK_PACKAGE_INSTALL_DIRECTORY   ${CPACK_PACKAGE_NAME})
set(CPACK_PACKAGE_VERSION_MAJOR       ${PROJECT_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR       ${PROJECT_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH       ${PROJECT_VERSION_PATCH})
set(CPACK_VERBATIM_VARIABLES          YES)
set(CPACK_PACKAGE_DESCRIPTION_FILE    "${CMAKE_CURRENT_LIST_DIR}/package_desc.txt")
set(CPACK_RESOURCE_FILE_LICENSE       "${PROJECT_SOURCE_DIR}/LICENSE.txt")
set(CPACK_RESOURCE_FILE_README        "${PROJECT_SOURCE_DIR}/README.md")

set(CPACK_RPM_FILE_NAME RPM-DEFAULT)
set(CPACK_DEBIAN_FILE_NAME DEB-DEFAULT) 

include(CPack)

=== sip/CMakeLists.txt ===
ADD_LIBRARY(libserialmod SHARED
    SerialPort.sip
	SerialPortConstants.sip
	exception.sip
	libserial.sip
	stdexcept.sip
	string.sip
	vector.sip
)

SET_TARGET_PROPERTIES(libserialmod PROPERTIES PREFIX "")

TARGET_LINK_LIBRARIES(libserialmod
	libserial_static
)

INSTALL(TARGETS libserialmod
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

# TODO - Generate the SIP output with CMake:
#ADD_CUSTOM_COMMAND(OUTPUT
#  ${CMAKE_CURRENT_BINARY_DIR}/SerialPort.h
#  COMMAND ${SIP_EXECUTABLE} -c ${CMAKE_CURRENT_BINARY_DIR}
#  ${CMAKE_CURRENT_SOURCE_DIR}/SerialPort.sip
#  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/SerialPort.sip
#  COMMENT "Processing ${CMAKE_CURRENT_SOURCE_DIR}/SerialPort.sip"
#  VERBATIM
#  )

=== src/CMakeLists.txt ===
set(LIBSERIAL_SOURCES
    SerialPort.cpp
    SerialStream.cpp
    SerialStreamBuf.cpp)

add_library(libserial_static STATIC ${LIBSERIAL_SOURCES})

#
# We already have "lib" prefix in the target name. Prevent CMake from adding
# another "lib" prefix.
#
set_target_properties(libserial_static PROPERTIES PREFIX "")
target_include_directories(libserial_static PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(libserial_static Threads::Threads)

#
# Install all our headers under the libserial subfolder of the include
# directory so that our headers do not conflict with similarly named headers
# from other libraries. Clients can either include our headers with libserial
# folder prefixed (for example, "#include <libserial/SerialPort.h>") or put the
# libserial folder in their include path (for example,
# "-I/usr/include/libserial").
#
install(DIRECTORY libserial
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

#
# The static library is always built as it is needed for unit tests but it is
# installed only if INSTALL_STATIC is set. 
#
if (INSTALL_STATIC)
    install(TARGETS libserial_static
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()
#
# Use the same name (libserial) for both the static and shared libraries
#
set_target_properties(libserial_static PROPERTIES OUTPUT_NAME libserial)

#
# Build and install the shared object library only if INSTALL_SHARED is set.
#
if (INSTALL_SHARED)
    add_library(libserial_shared SHARED ${LIBSERIAL_SOURCES})
    set_target_properties(libserial_shared PROPERTIES PREFIX "")
    set_target_properties(libserial_shared PROPERTIES OUTPUT_NAME libserial)
    target_include_directories(libserial_shared PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
    target_link_libraries(libserial_shared Threads::Threads)
    #
    # Add version numbering to the shared library. Based on the recommendations in
    # the following book:
    #
    # "Professional CMake: A Practical Guide" --Craig Scott 
    # (https://crascit.com/professional-cmake/)
    #
    set_target_properties(libserial_shared PROPERTIES
        VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}
        SOVERSION ${PROJECT_VERSION_MAJOR}
    )
    install(TARGETS libserial_shared
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

=== test/CMakeLists.txt ===
ADD_EXECUTABLE(UnitTests
  SerialPortUnitTests.cpp
  SerialStreamUnitTests.cpp
  MultiThreadUnitTests.cpp
  UnitTests.cpp
  )

TARGET_LINK_LIBRARIES(UnitTests
  libserial_static
  ${GTestMain}
)

ADD_EXECUTABLE(unit_tests
  unit_tests.cpp
  )

TARGET_LINK_LIBRARIES(unit_tests
  libserial_static
  ${Boost_LIBRARIES}
)

target_include_directories(UnitTests PRIVATE ${PROJECT_SOURCE_DIR}/src)
target_include_directories(unit_tests PRIVATE ${PROJECT_SOURCE_DIR}/src)


ADD_TEST(NAME UnitTests COMMAND UnitTests)

=== examples/example_project/CMakeLists.txt ===
#
# **NOTE** This example currently requires the LibSerial be built using
# autotools as the CMake build of LibSerial does not install a pkg-config
# file yet. Support for pkg-config will be added to CMake build shortly.
#
cmake_minimum_required(VERSION 3.8)

project(ExampleProject LANGUAGES C CXX VERSION 1.0.0)

set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)
#
# Prefer -pthread compiler and linker flag when using libpthread. This must
# be set before call to find_package(Threads).
#
set(THREADS_HAVE_PTHREAD_ARG 1)
find_package(Threads REQUIRED)
#
# If you've installed LibSerial in a non-standard location, please add it
# to PKG_CONFIG_PATH first. For example, if LibSerial is installed under
# /opt/libserial, set PKG_CONFIG_PATH environment variable to 
# /opt/libserial/lib/pkgconfig/ before running cmake for this example.
#
# export PKG_CONFIG_PATH=/opt/libserial/lib/pkgconfig/
#
find_package(PkgConfig)
pkg_check_modules(SERIAL libserial)

add_executable(ExampleProject example_project.cpp)
target_include_directories(ExampleProject PRIVATE ${SERIAL_INCLUDE_DIRS})
target_link_libraries(ExampleProject PRIVATE ${SERIAL_LDFLAGS} ${CMAKE_THREAD_LIBS_INIT})

=== debian/changelog ===
libserial (1.0.0+git20250903-2) unstable; urgency=medium

  * Mark boost not <nocheck>, needed also for nocheck build
    (Closes: #1116781), thanks Santiago Vila!

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 30 Sep 2025 20:22:59 +0200

libserial (1.0.0+git20250903-1) unstable; urgency=medium

  * New upstream version 1.0.0+git20250903
  * Drop patches now part of upstream codebase: {196,197,200}.patch

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 03 Sep 2025 08:18:03 +0200

=== debian/control ===
Source: libserial
Section: devel
Priority: optional
Homepage: https://github.com/crayzeewulf/libserial
Maintainer: Gianfranco Costamagna <locutusofborg@debian.org>
Uploaders: David Morris <dave@code-fish.co.uk>
Build-Depends: debhelper-compat (= 13),
               cmake,
               doxygen,
               graphviz,
               libgtest-dev,
               libboost-test-dev,
               python3-dev,
Build-Depends-Indep: python3-sphinx,
                     python3-sphinx-rtd-theme
Standards-Version: 4.7.2
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/libserial
Vcs-Git: https://salsa.debian.org/debian/libserial.git

Package: libserial1
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Serial port programming in C++ under POSIX operating system
 A collection of C++ classes which allow the serial port on POSIX systems to be
 accessed like an iostream object. Special functions are provided for setting
 various parameters of the serial port such as the baud rate, character size,
 flow control and other.
 .
 Provides the libserial library

Package: libserial-dev
Section: libdevel
Suggests: libserial-doc
Architecture: any
Depends: libserial1 (=${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: Serial port programming in C++ -- development files
 A collection of C++ classes which allow the serial port on POSIX systems to be
 accessed like an iostream object. Special functions are provided for setting
 various parameters of the serial port such as the baud rate, character size,
 flow control and other.
 .
 This package contains the development libraries and headers

Package: libserial-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: foreign
Description: Serial port programming in C++ -- documentation
 A collection of C++ classes which allow the serial port on POSIX systems to be
 accessed like an iostream object. Special functions are provided for setting
 various parameters of the serial port such as the baud rate, character size,
 flow control and other.
 .
 Provides the documentation for the library and development packages

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=cmake

execute_before_dh_auto_clean:
	rm -rf INSTALL docs/doxygen/html docs/build/man debian/doctrees

execute_before_dh_auto_build-indep:
	PYTHONPATH=. sphinx-build -bman docs/user_manual/ -d debian/doctrees docs/build/man

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	if [ -f obj-*/tests/unit_tests ]; then ./obj-*/tests/unit_tests; fi
endif

=== debian/tests/control ===
Tests: cmake-test
Depends: @, cmake, gcc, g++, build-essential
Restrictions: allow-stderr
